#ifndef SENSE_API_PROVIDER_DESC_H
#define SENSE_API_PROVIDER_DESC_H

#include <string>
#include <memory>
#include <vector>
#include <dlfcn.h>
#include <functional>
#include <user/senseApiDesc.h>

namespace smo {
namespace sense_api {

class SenseApiLib
{
private:
    friend class SenseApiManager;
    struct DlCloser
    {
        void operator()(void* handle) const
        {
            if (handle) {
                dlclose(handle);
            }
        }
    };

public:
    SenseApiLib(
        const std::string& path, void *_dlopen_handle,
        SMO_GET_SENSE_API_DESC_FN_TYPEDEF *descFn)
    :   libraryPath(path),
        dlopen_handle(_dlopen_handle, DlCloser()),
        SMO_GET_SENSE_API_DESC_FN_NAME(descFn)
    {}

    void setSenseApiDesc(const SenseApiDesc &desc)
    {
        if (!SenseApiDesc::sanityCheck(desc))
        {
            throw std::runtime_error(
                std::string(__func__) + ": Sanity check failed for sense API "
                "descriptor in library '" + libraryPath + "'");
        }

        senseApiDesc = desc;
    }

public:
    std::string libraryPath;
    std::unique_ptr<void, DlCloser> dlopen_handle;
    /* UNIMPLEMENTED: API-specific cmdline options. These affect this specific
     * sense api lib's behaviour globally.
     */
    std::vector<std::string> options;

    /**
     * @brief Every sense API lib is required to provide a function that returns
     * a SenseApiDesc struct. This struct states which API the lib uses to
     * connect Salmanoff to the sense provider it supports.
     *
     * This getter function should be visible to dlsym() so that Salmanoff can
     * find it in the lib after loading it, and call it.
     */
    std::function<SMO_GET_SENSE_API_DESC_FN_TYPEDEF>
        SMO_GET_SENSE_API_DESC_FN_NAME;

    /**
     * @brief Salmanoff will call the `SMO_GET_SENSE_API_DESC_FN_NAME` getter
     * function and use the data it provides in order to fill out this
     * descriptor.
     */
    SenseApiDesc senseApiDesc;

    std::string stringify() const {
        std::string result = "Library Path: " + libraryPath + "\n";
        result += "Sense API Descriptor: " + senseApiDesc.stringify() + "\n";
        return result;
    }
};

} // namespace sense_api
} // namespace smo

#endif // SENSE_API_PROVIDER_DESC_H
